---
title: "Scripting | Installing NPM Libraries | N3uron KB V1.22"
slug: "scripting-installing-npm-libraries"
description: "Scripting is a N3uron module designed to run custom scripts based on events like timers, tag changes, conditions, system start-up and system shutdown…"
updated: 2025-12-19T10:02:43Z
published: 2025-12-23T13:46:41Z
---

> ## Documentation Index
> Fetch the complete documentation index at: https://docs.n3uron.com/llms.txt
> Use this file to discover all available pages before exploring further.

# External Libraries

## [](/docs/scripting-installing-npm-libraries#_Toc36806229)

The N3uron Scripting module supports the use of any third-party JavaScript libraries with the following limitations:

- The library must be compatible with **NodeJS 22.19.0**
- Native libraries may or may not function correctly, depending on how they interact with the Node.js runtime. In general, N-API libraries and NAN libraries that are declared as context-aware are expected to work, although compatibility ultimately depends on the specific implementation of each library.

## Installing the pnpm package manager

We recommend using the **pnpm** package manager to simplify the installation of external libraries for use within the Scripting module. Refer to the [official installation documentation](https://pnpm.io/installation) for more details and troubleshooting.

### Windows

Using the Windows Package Manager (recommended):

```powershell
winget install -e --id pnpm.pnpm
```

Using PowerShell:

```powershell
Invoke-WebRequest https://get.pnpm.io/install.ps1 -UseBasicParsing | Invoke-Expression
```

Manual:

Download the latest binary from their [releases page](https://github.com/pnpm/pnpm/releases)

### Linux

Run the following command in a terminal:

```bash
curl -fsSL https://get.pnpm.io/install.sh | sh -
```

Manual:

Download the latest binary from their [releases page](https://github.com/pnpm/pnpm/releases)

## Installing NPM libraries

**Step 1:** Navigate to the N3uron installation directory. By default, this is `C:\Program Files\N3uron` on Windows and `/opt/n3uron` on Linux.

**Step 2:** Within the N3uron installation directory, navigate to the Scripting data folder: `data/&lt;ScriptingInstance&gt;`.

**Step 3:**Use pnpm to install the desired library from the [NPM](https://www.npmjs.com/):

```shell
pnpm install kafkajs
```

**Step 4:** Create a new **ExternalLibrary**in the Scripting module:

![](https://cdn.document360.io/54093ab5-6b22-4542-a265-04377931f11a/Images/Documentation/external%20library.png)

**Step 5:** Specify the library name and set the **Path**setting to `node_modules/&lt;LibraryName&gt;`

![](https://cdn.document360.io/54093ab5-6b22-4542-a265-04377931f11a/Images/Documentation/external%20library%202.png)

You are now ready to use the library within the Scripting module. [](/docs/scripting-installing-npm-libraries#_Toc36806230)
